(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/animations'), require('rxjs'), require('@bravobit/bb-foundation'), require('@angular/forms'), require('rxjs/operators'), require('@bravobit/bb-foundation/localize'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation/elements', ['exports', '@angular/core', '@angular/animations', 'rxjs', '@bravobit/bb-foundation', '@angular/forms', 'rxjs/operators', '@bravobit/bb-foundation/localize', '@angular/common'], factory) :
    (global = global || self, factory((global.bravobit = global.bravobit || {}, global.bravobit['bb-foundation'] = global.bravobit['bb-foundation'] || {}, global.bravobit['bb-foundation'].elements = {}), global.ng.core, global.ng.animations, global.rxjs, global.bravobit['bb-foundation'], global.ng.forms, global.rxjs.operators, global.bravobit['bb-foundation'].localize, global.ng.common));
}(this, function (exports, core, animations, rxjs, bbFoundation, forms, operators, localize, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDropdown = /** @class */ (function () {
        function BbDropdown(_elementRef) {
            this._elementRef = _elementRef;
            // State.
            this.visible$ = new rxjs.BehaviorSubject(false);
        }
        /**
         * @return {?}
         */
        BbDropdown.prototype.toggle = /**
         * @return {?}
         */
        function () {
            return this.visible$.next(!this.visible$.getValue());
        };
        /**
         * @return {?}
         */
        BbDropdown.prototype.close = /**
         * @return {?}
         */
        function () {
            return this.visible$.next(false);
        };
        /**
         * @param {?} target
         * @return {?}
         */
        BbDropdown.prototype.onDocumentClick = /**
         * @param {?} target
         * @return {?}
         */
        function (target) {
            if (!target) {
                return;
            }
            if (this._elementRef.nativeElement.contains(target)) {
                return;
            }
            return this.close();
        };
        BbDropdown.decorators = [
            { type: core.Component, args: [{
                        selector: 'bb-dropdown',
                        template: "<button (click)=\"toggle()\"\r\n        [class.opened]=\"visible$ | async\"\r\n        type=\"button\">\r\n    <ng-content></ng-content>\r\n</button>\r\n\r\n<div *ngIf=\"visible$ | async\"\r\n     [@dropdownMenuAnimation]=\"true\"\r\n     class=\"bb-dropdown-menu\"\r\n     role=\"list\">\r\n    <ng-content select=\"[bbDropdownItem], hr\"></ng-content>\r\n</div>\r\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        host: { 'class': 'bb-dropdown' },
                        preserveWhitespaces: false,
                        animations: [
                            animations.trigger('dropdownMenuAnimation', [
                                animations.transition(':enter', [
                                    // 1. Set the initial state.
                                    animations.style({ opacity: 0, transform: 'scale(0.9)' }),
                                    // 2. Start the animation to show the item.
                                    animations.animate('80ms cubic-bezier(0, 0, .2, 1)', animations.style({ opacity: 1, transform: 'scale(1)' }))
                                ]),
                                animations.transition(':leave', [
                                    // 1. Set the initial state.
                                    animations.style({ opacity: 1, transform: 'scale(1)' }),
                                    // 2. Start the animation to hide the item.
                                    animations.animate('80ms cubic-bezier(0, 0, .2, 1)', animations.style({ opacity: 0, transform: 'scale(0.9)' }))
                                ])
                            ])
                        ],
                        styles: [".bb-dropdown{position:relative;display:inline-block}.bb-dropdown.right>.bb-dropdown-menu{right:0;left:auto;-ms-transform-origin:top right;transform-origin:top right}.bb-dropdown-menu{left:0;top:100%;padding:0;z-index:10;display:block;margin:10px 0 0;border-radius:4px;position:absolute;list-style-type:none;background-color:#fff;border:1px solid #ccc;-ms-transform-origin:top left;transform-origin:top left;box-shadow:0 0 6px 0 rgba(0,0,0,.1)}.bb-dropdown-menu:after{width:0;top:-5px;height:0;right:5px;content:\"\";position:absolute;border-style:solid;border-width:0 10px 5px;border-color:transparent transparent #d9d9d9}.bb-dropdown-menu>hr{margin:0;height:1px;border:none;background-color:#ccc}.bb-dropdown-item{width:100%;border:none;line-height:1;display:block;cursor:pointer;text-align:left;font-weight:500;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;padding:12px 20px;white-space:nowrap;text-decoration:none;color:#676767!important;background-color:transparent;transition:background-color 250ms cubic-bezier(0,0,.2,1)}.bb-dropdown-item:first-child{border-top-left-radius:4px;border-top-right-radius:4px}.bb-dropdown-item:hover{background-color:#f6f6f6}.bb-dropdown-item:focus{box-shadow:0 0 0 3px rgba(220,224,233,.5)}.bb-dropdown-item:active{background-color:#f0f0f0}"]
                    }] }
        ];
        /** @nocollapse */
        BbDropdown.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        BbDropdown.propDecorators = {
            onDocumentClick: [{ type: core.HostListener, args: ['document:click', ['$event.target'],] }]
        };
        return BbDropdown;
    }());
    if (false) {
        /** @type {?} */
        BbDropdown.prototype.visible$;
        /**
         * @type {?}
         * @private
         */
        BbDropdown.prototype._elementRef;
    }
    var BbDropdownItem = /** @class */ (function () {
        function BbDropdownItem(_parent) {
            this._parent = _parent;
            // Inputs.
            this.closeOnClick = true;
        }
        /**
         * @return {?}
         */
        BbDropdownItem.prototype.onClick = /**
         * @return {?}
         */
        function () {
            if (!this.closeOnClick) {
                return;
            }
            this._parent && this._parent.close();
        };
        BbDropdownItem.decorators = [
            { type: core.Directive, args: [{
                        selector: '[bbDropdownItem]',
                        host: { 'class': 'bb-dropdown-item' }
                    },] }
        ];
        /** @nocollapse */
        BbDropdownItem.ctorParameters = function () { return [
            { type: BbDropdown, decorators: [{ type: core.Optional }, { type: core.Host }] }
        ]; };
        BbDropdownItem.propDecorators = {
            closeOnClick: [{ type: core.Input }],
            onClick: [{ type: core.HostListener, args: ['click',] }]
        };
        return BbDropdownItem;
    }());
    if (false) {
        /** @type {?} */
        BbDropdownItem.prototype.closeOnClick;
        /**
         * @type {?}
         * @private
         */
        BbDropdownItem.prototype._parent;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var ELEMENTS_ICONS = new core.InjectionToken('elements_icons');
    /** @type {?} */
    var ELEMENTS_ERRORS = new core.InjectionToken('elements_errors');
    /**
     * @record
     */
    function ElementsIconFont() { }
    if (false) {
        /** @type {?} */
        ElementsIconFont.prototype.namespace;
        /** @type {?} */
        ElementsIconFont.prototype.className;
        /** @type {?|undefined} */
        ElementsIconFont.prototype.inline;
        /** @type {?} */
        ElementsIconFont.prototype.type;
    }
    /**
     * @record
     */
    function ElementsIconImage() { }
    if (false) {
        /** @type {?} */
        ElementsIconImage.prototype.namespace;
        /** @type {?} */
        ElementsIconImage.prototype.name;
        /** @type {?} */
        ElementsIconImage.prototype.src;
        /** @type {?} */
        ElementsIconImage.prototype.type;
    }
    /**
     * @record
     */
    function ElementsIconUnknown() { }
    if (false) {
        /** @type {?} */
        ElementsIconUnknown.prototype.type;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbImagePickerBase = /** @class */ (function () {
        function BbImagePickerBase() {
        }
        return BbImagePickerBase;
    }());
    /** @type {?} */
    var BbImagePickerMixinBase = bbFoundation.mixinDisabled(bbFoundation.mixinGrouped(BbImagePickerBase));
    var BbImagePicker = /** @class */ (function (_super) {
        __extends(BbImagePicker, _super);
        function BbImagePicker(_converter) {
            var _this = _super.call(this) || this;
            _this._converter = _converter;
            // Inputs.
            _this.label = null;
            _this.placeholder = null;
            _this.styleDimensions = null;
            _this.cropDimensions = null;
            // Form.
            _this._value$ = new rxjs.BehaviorSubject(null);
            _this.valueChange = new core.EventEmitter();
            _this.onTouchedCallback = (/**
             * @return {?}
             */
            function () {
            });
            _this.onChangeCallback = (/**
             * @return {?}
             */
            function () {
            });
            return _this;
        }
        Object.defineProperty(BbImagePicker.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () {
                return this._value$.getValue();
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._value$.next(value);
                this.valueChange.emit(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbImagePicker.prototype, "image", {
            get: /**
             * @return {?}
             */
            function () {
                var _this = this;
                return this._value$.pipe(operators.map((/**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) { return value || _this.placeholder; })), operators.map((/**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) { return value ? "url(" + value + ")" : null; })));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} event
         * @return {?}
         */
        BbImagePicker.prototype.onFileChange = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            return __awaiter(this, void 0, void 0, function () {
                var file, _a, error_1;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // Grab the file from the event.
                            file = event.target.files[0];
                            // Check if the file exists.
                            if (!file || this.disabled) {
                                return [2 /*return*/];
                            }
                            _b.label = 1;
                        case 1:
                            _b.trys.push([1, 3, , 4]);
                            _a = this;
                            return [4 /*yield*/, this._converter.toDataUri(file, this.cropDimensions)];
                        case 2:
                            _a.value = _b.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            error_1 = _b.sent();
                            this.value = null;
                            return [3 /*break*/, 4];
                        case 4:
                            this.onChangeCallback(this.value);
                            if (this.fileInput && this.fileInput.nativeElement) {
                                this.fileInput.nativeElement.value = '';
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @return {?}
         */
        BbImagePicker.prototype.openFilePicker = /**
         * @return {?}
         */
        function () {
            if (this.disabled) {
                return;
            }
            // Execute a click on the file input.
            this.fileInput
                && this.fileInput.nativeElement
                && this.fileInput.nativeElement.click
                && this.fileInput.nativeElement.click();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        BbImagePicker.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.value = value;
        };
        /**
         * @param {?} method
         * @return {?}
         */
        BbImagePicker.prototype.registerOnChange = /**
         * @param {?} method
         * @return {?}
         */
        function (method) {
            this.onChangeCallback = method;
        };
        /**
         * @param {?} method
         * @return {?}
         */
        BbImagePicker.prototype.registerOnTouched = /**
         * @param {?} method
         * @return {?}
         */
        function (method) {
            this.onTouchedCallback = method;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        BbImagePicker.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
        };
        BbImagePicker.decorators = [
            { type: core.Component, args: [{
                        selector: 'bb-image-picker',
                        template: "<!-- The input that can open the file picker. -->\r\n<input #fileInput\r\n       (change)=\"onFileChange($event)\"\r\n       class=\"bb-image-picker-input\"\r\n       type=\"file\"\r\n       tabindex=\"-1\"\r\n       accept=\"image/*\">\r\n\r\n<span [style.width]=\"styleDimensions?.width || '100%'\"\r\n      [style.height]=\"styleDimensions?.height || '215px'\"\r\n      [style.background-image]=\"image | async\"\r\n      class=\"bb-image-input-image\">\r\n    </span>\r\n\r\n<button *ngIf=\"label as labelText\"\r\n        (click)=\"openFilePicker()\"\r\n        bb-button\r\n        class=\"bb-image-input-button\"\r\n        type=\"button\">\r\n    {{ labelText }}\r\n</button>\r\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            'class': 'bb-image-picker',
                            '[class.disabled]': 'disabled',
                            '[class.grouped]': 'grouped'
                        },
                        inputs: ['grouped', 'disabled'],
                        providers: [{ provide: forms.NG_VALUE_ACCESSOR, useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return BbImagePicker; })), multi: true }],
                        preserveWhitespaces: false,
                        styles: [".bb-image-picker{display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-direction:column;flex-direction:column}.bb-image-picker.circle>.bb-image-input-image{border-radius:50%}.bb-image-picker.grouped{margin-bottom:20px}.bb-image-picker.disabled{opacity:.5;cursor:default;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;pointer-events:none}.bb-image-picker-input{opacity:0;z-index:-1;width:.1px;height:.1px;overflow:hidden;position:absolute}.bb-image-input-image{display:-ms-flexbox;display:flex;cursor:default;position:relative;border-radius:4px;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;background:url(data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7) center center/cover no-repeat rgba(0,0,0,.2)}.bb-image-input-button{margin-top:10px}"]
                    }] }
        ];
        /** @nocollapse */
        BbImagePicker.ctorParameters = function () { return [
            { type: bbFoundation.ImageConverter }
        ]; };
        BbImagePicker.propDecorators = {
            fileInput: [{ type: core.ViewChild, args: ['fileInput', { static: true },] }],
            label: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            styleDimensions: [{ type: core.Input }],
            cropDimensions: [{ type: core.Input }],
            value: [{ type: core.Input }],
            valueChange: [{ type: core.Output }]
        };
        return BbImagePicker;
    }(BbImagePickerMixinBase));
    if (false) {
        /** @type {?} */
        BbImagePicker.prototype.fileInput;
        /** @type {?} */
        BbImagePicker.prototype.label;
        /** @type {?} */
        BbImagePicker.prototype.placeholder;
        /** @type {?} */
        BbImagePicker.prototype.styleDimensions;
        /** @type {?} */
        BbImagePicker.prototype.cropDimensions;
        /**
         * @type {?}
         * @private
         */
        BbImagePicker.prototype._value$;
        /** @type {?} */
        BbImagePicker.prototype.valueChange;
        /** @type {?} */
        BbImagePicker.prototype.onTouchedCallback;
        /** @type {?} */
        BbImagePicker.prototype.onChangeCallback;
        /**
         * @type {?}
         * @private
         */
        BbImagePicker.prototype._converter;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var nextUniqueId = 0;
    var BbFormControlBase = /** @class */ (function () {
        function BbFormControlBase() {
        }
        return BbFormControlBase;
    }());
    /** @type {?} */
    var BbFormControlMixinBase = bbFoundation.mixinDisabled(bbFoundation.mixinFocused(bbFoundation.mixinReadonly(bbFoundation.mixinGrouped(bbFoundation.mixinRequired(bbFoundation.mixinError(BbFormControlBase))))));
    var BbFormControl = /** @class */ (function (_super) {
        __extends(BbFormControl, _super);
        function BbFormControl(_errors) {
            var _this = _super.call(this) || this;
            _this._errors = _errors;
            // Inputs.
            _this.label = null;
            _this.hint = null;
            _this.customErrors = {};
            // Data.
            _this.arrow = false;
            _this._hideErrors = false;
            // Data.
            _this.labelId = "bb-form-control-" + nextUniqueId++;
            // Errors.
            _this.errors = new rxjs.Subject();
            return _this;
        }
        Object.defineProperty(BbFormControl.prototype, "hideErrors", {
            get: /**
             * @return {?}
             */
            function () {
                return this._hideErrors;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._hideErrors = bbFoundation.coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbFormControl.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.error$ = this.errors.pipe(operators.map((/**
             * @param {?} errors
             * @return {?}
             */
            function (errors) {
                if (!errors || _this.hideErrors) {
                    return null;
                }
                /** @type {?} */
                var token = Object.keys(errors)[0];
                /** @type {?} */
                var getError = _this.getDefaultError(token);
                /** @type {?} */
                var error = _this.customErrors[token] || (getError && getError(errors[token])) || null;
                return typeof error === 'string'
                    ? { token: error }
                    : error;
            })), operators.tap((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return _this.error = !!error; })));
        };
        /**
         * @param {?} token
         * @return {?}
         */
        BbFormControl.prototype.getDefaultError = /**
         * @param {?} token
         * @return {?}
         */
        function (token) {
            /** @type {?} */
            var errors = (this._errors || []).reduce((/**
             * @param {?} previous
             * @param {?} current
             * @return {?}
             */
            function (previous, current) {
                return __assign({}, previous, current);
            }), {});
            return errors[token] || null;
        };
        BbFormControl.decorators = [
            { type: core.Component, args: [{
                        selector: 'bb-form-control',
                        template: "<!-- Label of the form control. -->\r\n<label *ngIf=\"label as labelContent\"\r\n       [attr.for]=\"labelId\"\r\n       class=\"bb-form-control-label\">\r\n    <ng-template [bbTemplate]=\"labelContent\">\r\n        {{ labelContent }}\r\n    </ng-template>\r\n</label>\r\n\r\n<!-- The input with the addons. -->\r\n<div class=\"bb-form-control-container\">\r\n    <ng-content select=\"[bbPrefix]\"></ng-content>\r\n    <ng-content select=\"[bbInput]\"></ng-content>\r\n    <ng-content select=\"[bbSuffix]\"></ng-content>\r\n</div>\r\n\r\n<!-- The form control error. -->\r\n<ng-container *ngIf=\"error$ | async as error; else hintTemplate\">\r\n    <p *ngIf=\"error?.token | bbLocalize:{optional: true, data: error?.data} as message\"\r\n       class=\"bb-form-control-error\">\r\n        {{ message }}\r\n    </p>\r\n</ng-container>\r\n\r\n<!-- The form control hint. -->\r\n<ng-template #hintTemplate>\r\n    <p *ngIf=\"hint as hintContent\"\r\n       class=\"bb-form-control-hint\">\r\n        <ng-template [bbTemplate]=\"hintContent\">\r\n            {{ hintContent }}\r\n        </ng-template>\r\n    </p>\r\n</ng-template>\r\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            'class': 'bb-form-control',
                            '[class.readonly]': 'readonly',
                            '[class.required]': 'required',
                            '[class.disabled]': 'disabled',
                            '[class.focused]': 'focused',
                            '[class.grouped]': 'grouped',
                            '[class.arrow]': 'arrow',
                            '[class.error]': 'error'
                        },
                        inputs: ['grouped'],
                        preserveWhitespaces: false,
                        styles: [".bb-form-control{color:#2d3c4d;display:block}.bb-form-control>.bb-form-control-container>.bb-prefix,.bb-form-control>.bb-form-control-container>.bb-suffix{margin:0 8px;color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control.grouped{margin-bottom:20px}.bb-form-control.small{max-width:240px}.bb-form-control.medium{max-width:480px}.bb-form-control.large{max-width:720px}.bb-form-control.required>.bb-form-control-label:after{content:\"*\";color:#c23934;font-size:12px;line-height:1.5}.bb-form-control.disabled>.bb-form-control-container{cursor:default;pointer-events:none;background-color:rgba(204,204,204,.64)}.bb-form-control.disabled>.bb-form-control-container>input,.bb-form-control.disabled>.bb-form-control-container>select,.bb-form-control.disabled>.bb-form-control-container>textarea{color:#aaa}.bb-form-control.readonly>.bb-form-control-container{cursor:default;border:1px dotted #bdc4c9}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container{background-color:#fff;box-shadow:inset 0 3px 0 0 rgba(183,188,194,.2),0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(0,123,255,.2)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input::-webkit-input-placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea::-webkit-input-placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input::-moz-placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea::-moz-placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input:-ms-input-placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea:-ms-input-placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input::-ms-input-placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea::-ms-input-placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input::placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea::placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control.error>.bb-form-control-label{color:#c23934}.bb-form-control.error>.bb-form-control-container{border:1px solid #962b26;background-color:rgba(194,57,52,.25)!important;box-shadow:inset 0 3px 0 0 rgba(183,188,194,.2),0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>.bb-prefix,.bb-form-control.error>.bb-form-control-container>.bb-suffix{color:#c23934}.bb-form-control.error>.bb-form-control-container>input::-webkit-input-placeholder,.bb-form-control.error>.bb-form-control-container>textarea::-webkit-input-placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>input::-moz-placeholder,.bb-form-control.error>.bb-form-control-container>textarea::-moz-placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>input:-ms-input-placeholder,.bb-form-control.error>.bb-form-control-container>textarea:-ms-input-placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>input::-ms-input-placeholder,.bb-form-control.error>.bb-form-control-container>textarea::-ms-input-placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>input::placeholder,.bb-form-control.error>.bb-form-control-container>textarea::placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.arrow>.bb-form-control-container:after{width:20px;content:\"\";height:36px;display:-ms-flexbox;display:flex;min-width:20px;background-repeat:no-repeat;background-position:calc(100% - 8px) center;background-image:url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAA0AAAAGCAYAAAAYLBS/AAAACXBIWXMAAAsSAAALEgHS3X78AAAAWUlEQVQYlY3QsQ2DMAAEwMMTsAkrZInvWY3WXiIjJJtkA1OBRCIRf/nSffFTrXXGE4uxbCXJBw+8R0CStcAg3JKsUI7mDzzBBd3AC4Cp9/4z21o7znl9A9gBAf4fpjLTwkUAAAAASUVORK5CYII=)}.bb-form-control-container{width:100%;display:-ms-flexbox;display:flex;overflow:hidden;position:relative;border-radius:3px;-ms-flex-align:center;align-items:center;border:1px solid #b6bbc1;background-color:#fff8ff;transition-duration:250ms;transition-property:background-color,box-shadow;transition-timing-function:cubic-bezier(0,0,.2,1);box-shadow:inset 0 3px 0 0 rgba(183,188,194,.2),0 6px 6px -6px rgba(0,0,0,.1)}.bb-form-control-container>input::-webkit-input-placeholder,.bb-form-control-container>textarea::-webkit-input-placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input::-moz-placeholder,.bb-form-control-container>textarea::-moz-placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input:-ms-input-placeholder,.bb-form-control-container>textarea:-ms-input-placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input::-ms-input-placeholder,.bb-form-control-container>textarea::-ms-input-placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input::placeholder,.bb-form-control-container>textarea::placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input,.bb-form-control-container>select,.bb-form-control-container>textarea{margin:0;width:100%;border:none;color:#3d464d;font-size:16px;-webkit-appearance:none;-moz-appearance:none;appearance:none;background-color:transparent}.bb-form-control-container>input,.bb-form-control-container>select{height:36px;padding:0 8px}.bb-form-control-container>select::-ms-expand{display:none}.bb-form-control-container>input::-ms-clear,.bb-form-control-container>input::-ms-reveal{width:0;height:0;display:none}.bb-form-control-container>input::-webkit-search-cancel-button,.bb-form-control-container>input::-webkit-search-decoration,.bb-form-control-container>input::-webkit-search-results-button,.bb-form-control-container>input::-webkit-search-results-decoration{display:none}.bb-form-control-container>textarea{resize:none;padding:8px}.bb-form-control-label{color:#000;display:block;position:relative;margin-bottom:4px;transition:color 30ms cubic-bezier(0,0,.2,1)}.bb-form-control-error,.bb-form-control-hint{display:block;font-size:13px;margin-top:4px}.bb-form-control-error{color:#c23934}.bb-form-control-hint{color:#738694}"]
                    }] }
        ];
        /** @nocollapse */
        BbFormControl.ctorParameters = function () { return [
            { type: Array, decorators: [{ type: core.Optional }, { type: core.Inject, args: [ELEMENTS_ERRORS,] }] }
        ]; };
        BbFormControl.propDecorators = {
            label: [{ type: core.Input }],
            hint: [{ type: core.Input }],
            customErrors: [{ type: core.Input }],
            hideErrors: [{ type: core.Input }]
        };
        return BbFormControl;
    }(BbFormControlMixinBase));
    if (false) {
        /** @type {?} */
        BbFormControl.prototype.label;
        /** @type {?} */
        BbFormControl.prototype.hint;
        /** @type {?} */
        BbFormControl.prototype.customErrors;
        /** @type {?} */
        BbFormControl.prototype.arrow;
        /**
         * @type {?}
         * @private
         */
        BbFormControl.prototype._hideErrors;
        /** @type {?} */
        BbFormControl.prototype.labelId;
        /** @type {?} */
        BbFormControl.prototype.errors;
        /** @type {?} */
        BbFormControl.prototype.error$;
        /**
         * @type {?}
         * @private
         */
        BbFormControl.prototype._errors;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbSuffix = /** @class */ (function () {
        function BbSuffix() {
        }
        BbSuffix.decorators = [
            { type: core.Directive, args: [{
                        selector: '[bbSuffix]',
                        host: {
                            'class': 'bb-suffix'
                        }
                    },] }
        ];
        return BbSuffix;
    }());
    var BbPrefix = /** @class */ (function () {
        function BbPrefix() {
        }
        BbPrefix.decorators = [
            { type: core.Directive, args: [{
                        selector: '[bbPrefix]',
                        host: {
                            'class': 'bb-prefix'
                        }
                    },] }
        ];
        return BbPrefix;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbSelect = /** @class */ (function () {
        function BbSelect(_elementRef, _ngControl, _formControl, _form) {
            this._elementRef = _elementRef;
            this._ngControl = _ngControl;
            this._formControl = _formControl;
            this._form = _form;
            this.hasArrow = true;
            this._disabled = false;
            this._required = false;
        }
        /**
         * @return {?}
         */
        BbSelect.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this._subscription = rxjs.merge(this.formSubmit, this.statusChanges, this.onFormReset).pipe(operators.map((/**
             * @param {?} type
             * @return {?}
             */
            function (type) {
                /** @type {?} */
                var errors = _this._ngControl
                    ? _this._ngControl.errors
                    : null;
                // When the user submits always return the errors.
                if (type === 'form-submit') {
                    return errors;
                }
                /** @type {?} */
                var isSubmitted = _this._form && _this._form.submitted;
                /** @type {?} */
                var isPristine = _this._form && _this._form.pristine;
                return isSubmitted && !isPristine
                    ? errors
                    : null;
            }))).subscribe((/**
             * @param {?} errors
             * @return {?}
             */
            function (errors) { return _this._formControl.errors.next(errors); }));
            // Set an arrow on the form control if
            // it requires one.
            this._formControl.arrow = this.hasArrow;
        };
        /**
         * @return {?}
         */
        BbSelect.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._subscription && this._subscription.unsubscribe();
        };
        /**
         * @return {?}
         */
        BbSelect.prototype.focus = /**
         * @return {?}
         */
        function () {
            return this._elementRef
                && this._elementRef.nativeElement
                && this._elementRef.nativeElement.focus
                && this._elementRef.nativeElement.focus();
        };
        /**
         * @param {?} hasFocus
         * @return {?}
         */
        BbSelect.prototype.setFocus = /**
         * @param {?} hasFocus
         * @return {?}
         */
        function (hasFocus) {
            if (!this._formControl) {
                return;
            }
            this._formControl.focused = hasFocus;
        };
        Object.defineProperty(BbSelect.prototype, "id", {
            get: /**
             * @return {?}
             */
            function () {
                return this._formControl && this._formControl.labelId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbSelect.prototype, "disabled", {
            get: /**
             * @return {?}
             */
            function () {
                if (this._ngControl && this._ngControl.disabled !== null) {
                    return this._ngControl.disabled;
                }
                return this._disabled;
            },
            set: /**
             * @param {?} newValue
             * @return {?}
             */
            function (newValue) {
                this._disabled = bbFoundation.coerceBooleanProperty(newValue);
                if (!this._formControl) {
                    return;
                }
                this._formControl.disabled = this._disabled;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbSelect.prototype, "required", {
            get: /**
             * @return {?}
             */
            function () {
                return this._required;
            },
            set: /**
             * @param {?} newValue
             * @return {?}
             */
            function (newValue) {
                this._required = bbFoundation.coerceBooleanProperty(newValue);
                if (!this._formControl) {
                    return;
                }
                this._formControl.required = this._required;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbSelect.prototype, "formSubmit", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                if (!this._form) {
                    return rxjs.EMPTY;
                }
                return this._form.ngSubmit.pipe(operators.mapTo('form-submit'));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbSelect.prototype, "statusChanges", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                var _this = this;
                if (!this._ngControl) {
                    return rxjs.EMPTY;
                }
                return this._ngControl.statusChanges.pipe(operators.delay(1), operators.filter((/**
                 * @return {?}
                 */
                function () { return !_this._form ? true : !_this._form.pristine; })), operators.mapTo('control-status-change'));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbSelect.prototype, "onFormReset", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                var _this = this;
                if (!this._form) {
                    return rxjs.EMPTY;
                }
                return this._form.valueChanges.pipe(operators.delay(1), operators.filter((/**
                 * @return {?}
                 */
                function () { return !_this._form ? true : !_this._form.pristine; })), operators.mapTo('form-value-change'));
            },
            enumerable: true,
            configurable: true
        });
        BbSelect.decorators = [
            { type: core.Directive, args: [{
                        selector: 'select[bbInput]',
                        host: {
                            '[disabled]': 'disabled',
                            '(focus)': 'setFocus(true)',
                            '(blur)': 'setFocus(false)'
                        }
                    },] }
        ];
        /** @nocollapse */
        BbSelect.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: forms.NgControl, decorators: [{ type: core.Optional }] },
            { type: BbFormControl, decorators: [{ type: core.Optional }] },
            { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Host }] }
        ]; };
        BbSelect.propDecorators = {
            id: [{ type: core.HostBinding, args: ['attr.id',] }],
            disabled: [{ type: core.Input }],
            required: [{ type: core.Input }]
        };
        return BbSelect;
    }());
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        BbSelect.prototype.hasArrow;
        /**
         * @type {?}
         * @private
         */
        BbSelect.prototype._subscription;
        /**
         * @type {?}
         * @private
         */
        BbSelect.prototype._disabled;
        /**
         * @type {?}
         * @private
         */
        BbSelect.prototype._required;
        /**
         * @type {?}
         * @protected
         */
        BbSelect.prototype._elementRef;
        /**
         * @type {?}
         * @protected
         */
        BbSelect.prototype._ngControl;
        /**
         * @type {?}
         * @protected
         */
        BbSelect.prototype._formControl;
        /**
         * @type {?}
         * @protected
         */
        BbSelect.prototype._form;
    }
    var BbInput = /** @class */ (function (_super) {
        __extends(BbInput, _super);
        function BbInput(_elementRef, _ngControl, _formControl, _form) {
            var _this = _super.call(this, _elementRef, _ngControl, _formControl, _form) || this;
            _this._elementRef = _elementRef;
            _this._ngControl = _ngControl;
            _this._formControl = _formControl;
            _this._form = _form;
            _this.hasArrow = false;
            _this._readonly = false;
            return _this;
        }
        Object.defineProperty(BbInput.prototype, "readonly", {
            get: /**
             * @return {?}
             */
            function () {
                return this._readonly;
            },
            set: /**
             * @param {?} newValue
             * @return {?}
             */
            function (newValue) {
                this._readonly = bbFoundation.coerceBooleanProperty(newValue);
                if (!this._formControl) {
                    return;
                }
                this._formControl.readonly = this._readonly;
            },
            enumerable: true,
            configurable: true
        });
        BbInput.decorators = [
            { type: core.Directive, args: [{
                        selector: 'input[bbInput], textarea[bbInput]',
                        host: {
                            '[disabled]': 'disabled',
                            '[readonly]': 'readonly',
                            '(focus)': 'setFocus(true)',
                            '(blur)': 'setFocus(false)'
                        }
                    },] }
        ];
        /** @nocollapse */
        BbInput.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: forms.NgControl, decorators: [{ type: core.Optional }] },
            { type: BbFormControl, decorators: [{ type: core.Optional }] },
            { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Host }] }
        ]; };
        BbInput.propDecorators = {
            readonly: [{ type: core.Input }]
        };
        return BbInput;
    }(BbSelect));
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        BbInput.prototype.hasArrow;
        /**
         * @type {?}
         * @private
         */
        BbInput.prototype._readonly;
        /**
         * @type {?}
         * @protected
         */
        BbInput.prototype._elementRef;
        /**
         * @type {?}
         * @protected
         */
        BbInput.prototype._ngControl;
        /**
         * @type {?}
         * @protected
         */
        BbInput.prototype._formControl;
        /**
         * @type {?}
         * @protected
         */
        BbInput.prototype._form;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbFormGroupBase = /** @class */ (function () {
        function BbFormGroupBase() {
        }
        return BbFormGroupBase;
    }());
    /** @type {?} */
    var BbFormGroupMixinBase = bbFoundation.mixinGrouped(BbFormGroupBase);
    var BbFormGroup = /** @class */ (function (_super) {
        __extends(BbFormGroup, _super);
        function BbFormGroup() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BbFormGroup.decorators = [
            { type: core.Component, args: [{
                        selector: 'bb-form-group',
                        template: "<ng-content></ng-content>\r\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            'class': 'bb-form-group',
                            '[class.grouped]': 'grouped'
                        },
                        inputs: ['grouped'],
                        preserveWhitespaces: false,
                        styles: [".bb-form-group{width:100%;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;margin-top:-10px}.bb-form-group>*{margin-top:10px}.bb-form-group>:not(:first-child){margin-left:10px}.bb-form-group.start{-ms-flex-pack:start;justify-content:flex-start}.bb-form-group.end{-ms-flex-pack:end;justify-content:flex-end}.bb-form-group.vertical{-ms-flex-direction:column;flex-direction:column;-ms-flex-pack:normal;justify-content:normal}.bb-form-group.vertical>*{margin-left:0}.bb-form-group.vertical.start{-ms-flex-align:start;align-items:flex-start}.bb-form-group.vertical.end{-ms-flex-align:end;align-items:flex-end}.bb-form-group.grouped{margin-bottom:20px}"]
                    }] }
        ];
        return BbFormGroup;
    }(BbFormGroupMixinBase));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbFocusTrap = /** @class */ (function () {
        function BbFocusTrap(_platform, _elementRef) {
            this._platform = _platform;
            this._elementRef = _elementRef;
            this._focusableElements = [
                'a[href]',
                'area[href]',
                'input:not([disabled]):not([type="hidden"]):not([aria-hidden])',
                'select:not([disabled]):not([aria-hidden])',
                'textarea:not([disabled]):not([aria-hidden])',
                'button:not([disabled]):not([aria-hidden])',
                'iframe',
                'object',
                'embed',
                '[contenteditable]',
                '[tabindex]:not([tabindex^="-"])'
            ];
            this.focus = (/**
             * @param {?} element
             * @return {?}
             */
            function (element) {
                return element && element.focus && element.focus();
            });
            this.isTabEvent = (/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                return event.key === 'Tab' || event.keyCode === 9;
            });
        }
        /**
         * @param {?} event
         * @return {?}
         */
        BbFocusTrap.prototype.onKeydown = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            // Validate it is a tab event.
            if (!this.isTabEvent(event)) {
                return;
            }
            // Trap the focus inside the element.
            return this.trapFocus(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BbFocusTrap.prototype.trapFocus = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            // Validate that the DOM is available.
            if (!this._platform.isBrowser) {
                return;
            }
            // Get all focusable nodes.
            /** @type {?} */
            var focusableNodes = this.getFocusableNodes();
            // Focus the first available element if the focus
            // is not in the modal.
            if (!this.element.contains(document.activeElement)) {
                return this.focus(focusableNodes[0]);
            }
            /** @type {?} */
            var focusedItemIndex = focusableNodes.indexOf(document.activeElement);
            if (event.shiftKey && focusedItemIndex === 0) {
                this.focus(focusableNodes[focusableNodes.length - 1]);
                return event.preventDefault();
            }
            if (!event.shiftKey && focusedItemIndex === focusableNodes.length - 1) {
                this.focus(focusableNodes[0]);
                return event.preventDefault();
            }
        };
        Object.defineProperty(BbFocusTrap.prototype, "element", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                return this._elementRef.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        BbFocusTrap.prototype.getFocusableNodes = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var nodes = this.element.querySelectorAll(this._focusableElements);
            return Array.apply(void 0, __spread(nodes));
        };
        BbFocusTrap.decorators = [
            { type: core.Directive, args: [{
                        selector: '[bbFocusTrap]'
                    },] }
        ];
        /** @nocollapse */
        BbFocusTrap.ctorParameters = function () { return [
            { type: bbFoundation.Platform },
            { type: core.ElementRef }
        ]; };
        BbFocusTrap.propDecorators = {
            onKeydown: [{ type: core.HostListener, args: ['keydown', ['$event'],] }]
        };
        return BbFocusTrap;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        BbFocusTrap.prototype._focusableElements;
        /**
         * @type {?}
         * @private
         */
        BbFocusTrap.prototype.focus;
        /**
         * @type {?}
         * @private
         */
        BbFocusTrap.prototype.isTabEvent;
        /**
         * @type {?}
         * @private
         */
        BbFocusTrap.prototype._platform;
        /**
         * @type {?}
         * @private
         */
        BbFocusTrap.prototype._elementRef;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbButtonBase = /** @class */ (function () {
        function BbButtonBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return BbButtonBase;
    }());
    if (false) {
        /** @type {?} */
        BbButtonBase.prototype._elementRef;
    }
    /** @type {?} */
    var BbButtonMixinBase = bbFoundation.mixinDisabled(bbFoundation.mixinLoad(BbButtonBase));
    var BbButton = /** @class */ (function (_super) {
        __extends(BbButton, _super);
        function BbButton(_elementRef) {
            return _super.call(this, _elementRef) || this;
        }
        Object.defineProperty(BbButton.prototype, "nativeElement", {
            get: /**
             * @return {?}
             */
            function () {
                return this._elementRef.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbButton.prototype.focus = /**
         * @return {?}
         */
        function () {
            this.nativeElement && this.nativeElement.focus();
        };
        BbButton.decorators = [
            { type: core.Component, args: [{
                        selector: 'button[bb-button]',
                        template: "<bb-spinner [class.visible]=\"loading\"\r\n            class=\"bb-button-spinner small\">\r\n</bb-spinner>\r\n\r\n<ng-content></ng-content>\r\n",
                        exportAs: 'bbButton',
                        host: {
                            'class': 'bb-button',
                            '[class.loading]': 'loading',
                            '[attr.disabled]': 'disabled || loading || null'
                        },
                        inputs: ['disabled', 'loading'],
                        encapsulation: core.ViewEncapsulation.None,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [".bb-button{height:36px;padding:0 8px;cursor:pointer;font-size:16px;font-weight:500;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;position:relative;font-style:normal;border-radius:4px;text-align:center;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;text-decoration:none;-ms-flex-pack:center;justify-content:center;background-color:#fff;color:#2d3c4d!important;border:1px solid #d4d8e1;transition-duration:.2s;box-shadow:0 6px 6px -6px rgba(0,0,0,.1);transition-timing-function:cubic-bezier(0,0,.2,1);transition-property:padding-left,background-color,box-shadow}.bb-button:hover{background-color:#fcfcfb}.bb-button:active,.bb-button:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(220,224,233,.5)}.bb-button.full{width:100%}.bb-button.full.loading{padding-left:42px}.bb-button.primary{border-color:#2f2b85;color:#fff!important;background-color:#5b53ff}.bb-button.primary:hover{background-color:#564ee6}.bb-button.primary:active,.bb-button.primary:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(91,83,255,.5)}.bb-button.destructive{border-color:#8f2020;color:#fff!important;background-color:#d32f2f}.bb-button.destructive:hover{background-color:#c32929}.bb-button.destructive:active,.bb-button.destructive:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(211,47,47,.5)}.bb-button.loading,.bb-button.loading:active,.bb-button.loading:focus,.bb-button.loading:hover,.bb-button:disabled,.bb-button:disabled:active,.bb-button:disabled:focus,.bb-button:disabled:hover,.bb-button[disabled],.bb-button[disabled]:active,.bb-button[disabled]:focus,.bb-button[disabled]:hover{opacity:.4;cursor:default;box-shadow:none}.bb-button-spinner{width:0;opacity:0;overflow:hidden;visibility:hidden;padding:0!important;transition:width .2s cubic-bezier(0,0,.2,1),opacity .1s cubic-bezier(0,0,.2,1)}.bb-button-spinner.visible{opacity:1;width:20px;margin-right:8px;visibility:visible}.bb-button.loading.full>.bb-button-spinner{left:8px;margin-right:0;position:absolute}"]
                    }] }
        ];
        /** @nocollapse */
        BbButton.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        return BbButton;
    }(BbButtonMixinBase));
    var BbAnchor = /** @class */ (function (_super) {
        __extends(BbAnchor, _super);
        function BbAnchor(_elementRef) {
            return _super.call(this, _elementRef) || this;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        BbAnchor.prototype.stopDisabledEvents = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            // If the button is not disabled (and not loading) let all events pass.
            if (!this.disabled && !this.loading) {
                return;
            }
            // If the button is disabled and/or loading stop
            // the event from bubbling up.
            event.preventDefault();
            event.stopImmediatePropagation();
        };
        BbAnchor.decorators = [
            { type: core.Component, args: [{
                        selector: 'a[bb-button]',
                        template: "<bb-spinner [class.visible]=\"loading\"\r\n            class=\"bb-button-spinner small\">\r\n</bb-spinner>\r\n\r\n<ng-content></ng-content>\r\n",
                        exportAs: 'bbButton, bbAnchor',
                        host: {
                            'class': 'bb-button',
                            '[attr.tabindex]': '(disabled || loading) ? -1 : (tabIndex || 0)',
                            '[attr.disabled]': 'disabled || loading || null',
                            '[attr.aria-disabled]': '(disabled || loading).toString()',
                            '(click)': 'stopDisabledEvents($event)'
                        },
                        inputs: ['disabled'],
                        encapsulation: core.ViewEncapsulation.None,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [".bb-button{height:36px;padding:0 8px;cursor:pointer;font-size:16px;font-weight:500;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;position:relative;font-style:normal;border-radius:4px;text-align:center;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;text-decoration:none;-ms-flex-pack:center;justify-content:center;background-color:#fff;color:#2d3c4d!important;border:1px solid #d4d8e1;transition-duration:.2s;box-shadow:0 6px 6px -6px rgba(0,0,0,.1);transition-timing-function:cubic-bezier(0,0,.2,1);transition-property:padding-left,background-color,box-shadow}.bb-button:hover{background-color:#fcfcfb}.bb-button:active,.bb-button:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(220,224,233,.5)}.bb-button.full{width:100%}.bb-button.full.loading{padding-left:42px}.bb-button.primary{border-color:#2f2b85;color:#fff!important;background-color:#5b53ff}.bb-button.primary:hover{background-color:#564ee6}.bb-button.primary:active,.bb-button.primary:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(91,83,255,.5)}.bb-button.destructive{border-color:#8f2020;color:#fff!important;background-color:#d32f2f}.bb-button.destructive:hover{background-color:#c32929}.bb-button.destructive:active,.bb-button.destructive:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(211,47,47,.5)}.bb-button.loading,.bb-button.loading:active,.bb-button.loading:focus,.bb-button.loading:hover,.bb-button:disabled,.bb-button:disabled:active,.bb-button:disabled:focus,.bb-button:disabled:hover,.bb-button[disabled],.bb-button[disabled]:active,.bb-button[disabled]:focus,.bb-button[disabled]:hover{opacity:.4;cursor:default;box-shadow:none}.bb-button-spinner{width:0;opacity:0;overflow:hidden;visibility:hidden;padding:0!important;transition:width .2s cubic-bezier(0,0,.2,1),opacity .1s cubic-bezier(0,0,.2,1)}.bb-button-spinner.visible{opacity:1;width:20px;margin-right:8px;visibility:visible}.bb-button.loading.full>.bb-button-spinner{left:8px;margin-right:0;position:absolute}"]
                    }] }
        ];
        /** @nocollapse */
        BbAnchor.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        BbAnchor.propDecorators = {
            tabIndex: [{ type: core.Input }]
        };
        return BbAnchor;
    }(BbButton));
    if (false) {
        /** @type {?} */
        BbAnchor.prototype.tabIndex;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbTemplate = /** @class */ (function () {
        function BbTemplate(_templateRef, _viewContainerRef) {
            this._templateRef = _templateRef;
            this._viewContainerRef = _viewContainerRef;
        }
        Object.defineProperty(BbTemplate.prototype, "bbTemplate", {
            set: /**
             * @param {?} content
             * @return {?}
             */
            function (content) {
                // Get the template.
                /** @type {?} */
                var template = content instanceof core.TemplateRef
                    ? content
                    : this._templateRef;
                // Clear the view container ref and create the view.
                this._viewContainerRef.clear();
                this._viewContainerRef.createEmbeddedView(template);
            },
            enumerable: true,
            configurable: true
        });
        BbTemplate.decorators = [
            { type: core.Directive, args: [{
                        selector: '[bbTemplate]'
                    },] }
        ];
        /** @nocollapse */
        BbTemplate.ctorParameters = function () { return [
            { type: core.TemplateRef },
            { type: core.ViewContainerRef }
        ]; };
        BbTemplate.propDecorators = {
            bbTemplate: [{ type: core.Input }]
        };
        return BbTemplate;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        BbTemplate.prototype._templateRef;
        /**
         * @type {?}
         * @private
         */
        BbTemplate.prototype._viewContainerRef;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbAutosize = /** @class */ (function () {
        function BbAutosize(_renderer, _elementRef) {
            this._renderer = _renderer;
            this._elementRef = _elementRef;
            // Min/max heights for the textarea.
            this.minHeight = null;
            this.maxHeight = null;
        }
        Object.defineProperty(BbAutosize.prototype, "element", {
            get: /**
             * @return {?}
             */
            function () {
                return this._elementRef.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbAutosize.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            // Update the styles after the DOM has loaded.
            this.updateStyles();
        };
        /**
         * @return {?}
         */
        BbAutosize.prototype.onWindowResize = /**
         * @return {?}
         */
        function () {
            // Update the styles when the window is resized.
            this.updateStyles();
        };
        /**
         * @return {?}
         */
        BbAutosize.prototype.onInputReceived = /**
         * @return {?}
         */
        function () {
            // Update the styles after the textarea received input.
            this.updateStyles();
        };
        /**
         * @private
         * @return {?}
         */
        BbAutosize.prototype.updateStyles = /**
         * @private
         * @return {?}
         */
        function () {
            // If the element does not exist exit.
            if (!this.element) {
                return;
            }
            // If the scroll height is the same height as the element, then exit.
            if (this.element.style.height === this.element.scrollHeight + 'px') {
                return;
            }
            // Set the style of the element to 'auto' to reset the element.
            this._renderer.setStyle(this.element, 'height', 'auto');
            // Set the style of the element to the scroll height to make
            // the element fit all the text.
            this._renderer.setStyle(this.element, 'height', this.element.scrollHeight + 'px');
        };
        BbAutosize.decorators = [
            { type: core.Directive, args: [{
                        selector: 'textarea[bbAutosize]'
                    },] }
        ];
        /** @nocollapse */
        BbAutosize.ctorParameters = function () { return [
            { type: core.Renderer2 },
            { type: core.ElementRef }
        ]; };
        BbAutosize.propDecorators = {
            minHeight: [{ type: core.Input }, { type: core.HostBinding, args: ['style.min-height',] }],
            maxHeight: [{ type: core.Input }, { type: core.HostBinding, args: ['style.max-height',] }],
            onWindowResize: [{ type: core.HostListener, args: ['window:resize',] }],
            onInputReceived: [{ type: core.HostListener, args: ['input',] }]
        };
        return BbAutosize;
    }());
    if (false) {
        /** @type {?} */
        BbAutosize.prototype.minHeight;
        /** @type {?} */
        BbAutosize.prototype.maxHeight;
        /**
         * @type {?}
         * @private
         */
        BbAutosize.prototype._renderer;
        /**
         * @type {?}
         * @private
         */
        BbAutosize.prototype._elementRef;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var nextUniqueId$1 = 0;
    var BbCheckboxBase = /** @class */ (function () {
        function BbCheckboxBase() {
        }
        return BbCheckboxBase;
    }());
    /** @type {?} */
    var BbCheckboxMixinBase = bbFoundation.mixinDisabled(bbFoundation.mixinGrouped(BbCheckboxBase));
    var BbCheckbox = /** @class */ (function (_super) {
        __extends(BbCheckbox, _super);
        function BbCheckbox() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            // Data.
            _this.labelId = "bb-checkbox-" + nextUniqueId$1++;
            _this._checked = false;
            // Methods.
            _this.onChange = (/**
             * @return {?}
             */
            function () {
            });
            _this.onTouched = (/**
             * @return {?}
             */
            function () {
            });
            return _this;
        }
        Object.defineProperty(BbCheckbox.prototype, "checked", {
            get: /**
             * @return {?}
             */
            function () {
                return this._checked;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (value != this.checked) {
                    this._checked = value;
                    // this._changeDetection.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} fn
         * @return {?}
         */
        BbCheckbox.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        BbCheckbox.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        BbCheckbox.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
        };
        /**
         * @param {?} newValue
         * @return {?}
         */
        BbCheckbox.prototype.writeValue = /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this.checked = newValue;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BbCheckbox.prototype.onInteractionEvent = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            // Stop the propagation to prevent it from bubbling up.
            event.stopPropagation();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BbCheckbox.prototype.onInputClick = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            // Stop the propagation to prevent it from bubbling up.
            event.stopPropagation();
            // Toggle the value.
            this.checked = !this.checked;
            // Emit the change event.
            this.onChange && this.onChange(this.checked);
        };
        BbCheckbox.decorators = [
            { type: core.Component, args: [{
                        selector: 'bb-checkbox',
                        template: "<input [id]=\"labelId\"\r\n       [checked]=\"checked\"\r\n       [disabled]=\"disabled\"\r\n       (change)=\"onInteractionEvent($event)\"\r\n       (click)=\"onInputClick($event)\"\r\n       class=\"bb-checkbox-input\"\r\n       type=\"checkbox\">\r\n\r\n<label [for]=\"labelId\"\r\n       class=\"bb-checkbox-label\">\r\n    <span>\r\n        <svg width=\"12px\"\r\n             height=\"10px\"\r\n             viewbox=\"0 0 12 10\">\r\n            <polyline points=\"1.5 6 4.5 9 10.5 1\"></polyline>\r\n        </svg>\r\n    </span>\r\n    <span>\r\n        <ng-content></ng-content>\r\n    </span>\r\n</label>\r\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        providers: [
                            { provide: forms.NG_VALUE_ACCESSOR, useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return BbCheckbox; })), multi: true }
                        ],
                        host: {
                            'class': 'bb-checkbox',
                            '[class.grouped]': 'grouped'
                        },
                        inputs: ['grouped', 'disabled'],
                        preserveWhitespaces: false,
                        styles: [".bb-checkbox{display:block}.bb-checkbox+.bb-checkbox{margin-top:5px}.bb-checkbox.grouped{margin-bottom:20px}.bb-checkbox-input{display:none}.bb-checkbox-label{margin:0;cursor:pointer;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.bb-checkbox-label>span{display:inline-block;vertical-align:middle;transform:translate3d(0,0,0)}.bb-checkbox-label>span:first-child{width:18px;height:18px;position:relative;border-radius:3px;vertical-align:middle;border:1px solid #bdc4c9;transition:.2s}.bb-checkbox-label>span:last-child{padding-left:8px}.bb-checkbox-label>span:first-child>svg{top:3px;left:2px;fill:none;stroke:#fff;stroke-width:2;position:absolute;stroke-linecap:round;stroke-linejoin:round;stroke-dasharray:16px;stroke-dashoffset:16px;transition:.3s;transform:translate3d(0,0,0)}.bb-checkbox-input:checked+.bb-checkbox-label>span:first-child{border-color:#5b53ff;background-color:#5b53ff}.bb-checkbox-input:checked+.bb-checkbox-label>span:first-child>svg{stroke-dashoffset:0}.bb-checkbox-input:disabled+.bb-checkbox-label{cursor:default;pointer-events:none}.bb-checkbox-input:disabled:checked+.bb-checkbox-label>span:first-child{border-color:rgba(204,204,204,.64);background-color:rgba(204,204,204,.64)}"]
                    }] }
        ];
        BbCheckbox.propDecorators = {
            checked: [{ type: core.Input }]
        };
        return BbCheckbox;
    }(BbCheckboxMixinBase));
    if (false) {
        /** @type {?} */
        BbCheckbox.prototype.labelId;
        /**
         * @type {?}
         * @private
         */
        BbCheckbox.prototype._checked;
        /** @type {?} */
        BbCheckbox.prototype.onChange;
        /** @type {?} */
        BbCheckbox.prototype.onTouched;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbSpinnerBase = /** @class */ (function () {
        function BbSpinnerBase() {
        }
        return BbSpinnerBase;
    }());
    /** @type {?} */
    var BbSpinnerMixinBase = bbFoundation.mixinDisabled(BbSpinnerBase);
    var BbSpinner = /** @class */ (function (_super) {
        __extends(BbSpinner, _super);
        function BbSpinner() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            // Inputs.
            _this.color = '#303f9f';
            _this.alt = 'Loading...';
            return _this;
        }
        BbSpinner.decorators = [
            { type: core.Component, args: [{
                        selector: 'bb-spinner',
                        template: "<!--\r\n    The spinner element.\r\n\r\n    This element contains a circle with a 25% bar that spins\r\n    indefinitely. The border color can be set via the \"color\"\r\n    property.\r\n-->\r\n<div class=\"bb-spinner-container\">\r\n    <div [style.border-left-color]=\"color\"\r\n         [class.disabled]=\"disabled\"\r\n         class=\"bb-spinner-loader\"\r\n         aria-live=\"assertive\"\r\n         role=\"alert\">\r\n        {{ alt }}\r\n    </div>\r\n    <ng-content select=\"img\"></ng-content>\r\n</div>\r\n\r\n<!--\r\n    The content of the spinner.\r\n\r\n    This element contains the content of the spinner. The user\r\n    can set the content inside the tag.\r\n-->\r\n<span class=\"bb-spinner-content\">\r\n    <ng-content></ng-content>\r\n</span>\r\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        host: { 'class': 'bb-spinner' },
                        inputs: ['color', 'alt', 'disabled'],
                        preserveWhitespaces: false,
                        styles: [".bb-spinner{color:#565656;padding:20px 0;text-align:center;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;-ms-flex-direction:column;flex-direction:column;-ms-flex-pack:center;justify-content:center}.bb-spinner.block{display:-ms-flexbox;display:flex}.bb-spinner.inverse .bb-spinner-loader{border-color:rgba(255,255,255,.15)}.bb-spinner.inverse .bb-spinner-content{color:rgba(255,255,255,.5)}.bb-spinner.small .bb-spinner-loader,.bb-spinner.small .bb-spinner-loader:after{width:20px;height:20px;min-width:20px;min-height:20px}.bb-spinner.small .bb-spinner-loader{border-width:2px}.bb-spinner.small .bb-spinner-content{font-size:12px}.bb-spinner.medium .bb-spinner-loader,.bb-spinner.medium .bb-spinner-loader:after{width:60px;height:60px;min-width:60px;min-height:60px}.bb-spinner.medium .bb-spinner-loader{border-width:4px}.bb-spinner.medium .bb-spinner-content{font-size:16px}.bb-spinner.large .bb-spinner-loader,.bb-spinner.large .bb-spinner-loader:after{width:100px;height:100px;min-width:100px;min-height:100px}.bb-spinner.large .bb-spinner-loader{border-width:6px}.bb-spinner.large .bb-spinner-content{font-size:20px}.bb-spinner.horizontal{text-align:left;-ms-flex-direction:row;flex-direction:row}.bb-spinner.horizontal .bb-spinner-content:not(:empty){margin-left:10px;margin-top:0}.bb-spinner.vertical{text-align:center;-ms-flex-direction:column;flex-direction:column}.bb-spinner.vertical .bb-spinner-content:not(:empty){margin-left:0;margin-top:10px}.bb-spinner-container{position:relative}.bb-spinner-container>img{top:20%;left:20%;width:60%;height:60%;position:absolute}.bb-spinner-loader{margin:0;padding:0;overflow:hidden;text-indent:100%;position:relative;display:inline-block;vertical-align:middle;border:4px solid #f2f4f6;-webkit-animation:1s linear infinite spin;animation:1s linear infinite spin}.bb-spinner-loader,.bb-spinner-loader:after{width:60px;height:60px;min-width:60px;min-height:60px;border-radius:50%}.bb-spinner-loader.disabled{cursor:default;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;pointer-events:none;-webkit-animation-play-state:paused;animation-play-state:paused}.bb-spinner-content:not(:empty){font-size:16px;margin-top:10px;font-weight:500}@-webkit-keyframes spin{from{transform:rotate(0)}to{transform:rotate(360deg)}}@keyframes spin{from{transform:rotate(0)}to{transform:rotate(360deg)}}"]
                    }] }
        ];
        BbSpinner.propDecorators = {
            color: [{ type: core.Input }],
            alt: [{ type: core.Input }]
        };
        return BbSpinner;
    }(BbSpinnerMixinBase));
    if (false) {
        /** @type {?} */
        BbSpinner.prototype.color;
        /** @type {?} */
        BbSpinner.prototype.alt;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbFocus = /** @class */ (function () {
        function BbFocus(_zone, _platform, _elementRef) {
            this._zone = _zone;
            this._platform = _platform;
            this._elementRef = _elementRef;
        }
        Object.defineProperty(BbFocus.prototype, "nativeElement", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                return this._elementRef.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbFocus.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            // Run the method outside the Angular zone.
            this._zone.runOutsideAngular((/**
             * @return {?}
             */
            function () { return _this.focus(); }));
        };
        /**
         * @private
         * @return {?}
         */
        BbFocus.prototype.focus = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            // Check if set timeout exists and the user is
            // using the site on desktop devices.
            if (!this._platform.isDesktop || !setTimeout) {
                return;
            }
            // Check if the element and the focus method exist, if so focus the element.
            if (!this.nativeElement || !this.nativeElement.focus) {
                return;
            }
            // Execute the focus method in a timeout.
            setTimeout((/**
             * @return {?}
             */
            function () { return _this.nativeElement.focus(); }), 0);
        };
        BbFocus.decorators = [
            { type: core.Directive, args: [{
                        selector: '[bbFocus]'
                    },] }
        ];
        /** @nocollapse */
        BbFocus.ctorParameters = function () { return [
            { type: core.NgZone },
            { type: bbFoundation.Platform },
            { type: core.ElementRef }
        ]; };
        return BbFocus;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        BbFocus.prototype._zone;
        /**
         * @type {?}
         * @private
         */
        BbFocus.prototype._platform;
        /**
         * @type {?}
         * @private
         */
        BbFocus.prototype._elementRef;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbIcon = /** @class */ (function () {
        function BbIcon(_registry) {
            this._registry = _registry;
            // Data.
            this._src = null;
            // State.
            this.state$ = new rxjs.BehaviorSubject(null);
            this.alt = null;
            this.size = 24;
            this._ariaHidden = true;
            this.warn = (/**
             * @param {?} content
             * @return {?}
             */
            function (content) {
                return console && console.warn && console.warn(content);
            });
        }
        Object.defineProperty(BbIcon.prototype, "src", {
            get: /**
             * @return {?}
             */
            function () {
                return this._src;
            },
            set: /**
             * @param {?} newValue
             * @return {?}
             */
            function (newValue) {
                this.state$.next(this.convert(newValue));
                this._src = newValue;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbIcon.prototype, "ariaHidden", {
            get: /**
             * @return {?}
             */
            function () {
                return this._ariaHidden;
            },
            set: /**
             * @param {?} newValue
             * @return {?}
             */
            function (newValue) {
                this._ariaHidden = bbFoundation.coerceBooleanProperty(newValue);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @param {?} src
         * @return {?}
         */
        BbIcon.prototype.convert = /**
         * @private
         * @param {?} src
         * @return {?}
         */
        function (src) {
            var _this = this;
            var _a = __read((src || '').split(':'), 2), namespace = _a[0], value = _a[1];
            /** @type {?} */
            var onError = (/**
             * @return {?}
             */
            function () {
                _this.warn("ElementsModule: The icon with src \"" + src + "\" could not be rendered correctly; Did you put a correct src attribute?");
                return { type: 'unknown' };
            });
            if (!namespace || !value || !this._registry) {
                return onError();
            }
            // Try to find a image icon.
            /** @type {?} */
            var imageIcon = this.findImageIcon(namespace, value);
            if (imageIcon) {
                return imageIcon;
            }
            // Try to find a font icon.
            /** @type {?} */
            var fontIcon = this.findFontIcon(namespace, value);
            if (fontIcon) {
                return fontIcon;
            }
            // Return the on error function.
            return onError();
        };
        /**
         * @private
         * @param {?} namespace
         * @param {?} value
         * @return {?}
         */
        BbIcon.prototype.findImageIcon = /**
         * @private
         * @param {?} namespace
         * @param {?} value
         * @return {?}
         */
        function (namespace, value) {
            /** @type {?} */
            var data = this._registry.find((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item['namespace'] === namespace && item['name'] === value; }));
            if (!data) {
                return null;
            }
            return { type: data['type'], src: data['src'] };
        };
        /**
         * @private
         * @param {?} namespace
         * @param {?} content
         * @return {?}
         */
        BbIcon.prototype.findFontIcon = /**
         * @private
         * @param {?} namespace
         * @param {?} content
         * @return {?}
         */
        function (namespace, content) {
            /** @type {?} */
            var data = this._registry.find((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item['namespace'] === namespace; }));
            if (!data) {
                return null;
            }
            /** @type {?} */
            var isInline = data['inline'] || false;
            if (isInline) {
                return { type: data['type'], className: "" + data['className'] + content };
            }
            return { type: data['type'], className: data['className'], content: content };
        };
        BbIcon.decorators = [
            { type: core.Component, args: [{
                        selector: 'bb-icon',
                        template: "<ng-container *ngIf=\"state$ | async as data\"\r\n              [ngSwitch]=\"data?.type\">\r\n    <i *ngSwitchCase=\"'font'\"\r\n       [class]=\"data?.className\">\r\n        {{ data?.content }}\r\n    </i>\r\n    <img *ngSwitchCase=\"'image'\"\r\n         [src]=\"data?.src\"\r\n         [alt]=\"alt\">\r\n    <svg *ngSwitchCase=\"'unknown'\"\r\n         viewBox=\"0 0 1 1\">\r\n        <rect x=\"0\" y=\"0\" width=\"1\" height=\"1\" fill=\"#c5c5c5\"></rect>\r\n    </svg>\r\n</ng-container>\r\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            'class': 'bb-icon',
                            '[attr.aria-hidden]': 'ariaHidden',
                            '[style.width.px]': 'size',
                            '[style.height.px]': 'size',
                            '[style.min-width.px]': 'size',
                            '[style.min-height.px]': 'size'
                        },
                        preserveWhitespaces: false,
                        styles: [".bb-icon{display:-ms-flexbox;display:flex;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center}.bb-icon>img,.bb-icon>svg{width:100%;height:100%;display:-ms-flexbox;display:flex}"]
                    }] }
        ];
        /** @nocollapse */
        BbIcon.ctorParameters = function () { return [
            { type: Array, decorators: [{ type: core.Optional }, { type: core.Inject, args: [ELEMENTS_ICONS,] }] }
        ]; };
        BbIcon.propDecorators = {
            alt: [{ type: core.Input }],
            size: [{ type: core.Input }],
            src: [{ type: core.Input }],
            ariaHidden: [{ type: core.Input }]
        };
        return BbIcon;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        BbIcon.prototype._src;
        /** @type {?} */
        BbIcon.prototype.state$;
        /** @type {?} */
        BbIcon.prototype.alt;
        /** @type {?} */
        BbIcon.prototype.size;
        /**
         * @type {?}
         * @private
         */
        BbIcon.prototype._ariaHidden;
        /**
         * @type {?}
         * @private
         */
        BbIcon.prototype.warn;
        /**
         * @type {?}
         * @private
         */
        BbIcon.prototype._registry;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbTag = /** @class */ (function () {
        function BbTag() {
            // Outputs.
            this.onClose = new core.EventEmitter();
        }
        BbTag.decorators = [
            { type: core.Component, args: [{
                        selector: 'bb-tag',
                        template: "<ng-content></ng-content>\r\n\r\n<button *ngIf=\"onClose?.observers?.length > 0\"\r\n        (click)=\"onClose.emit()\"\r\n        type=\"button\">\r\n    Close\r\n</button>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: { 'class': 'bb-tag' },
                        styles: [".bb-tag{cursor:default;padding:0 7px;font-size:12px;list-style:none;line-height:20px;border-radius:4px;white-space:nowrap;display:inline-block;color:rgba(0,0,0,.65);border:1px solid #d9d9d9;background-color:#fafafa;font-variant:tabular-nums;-webkit-font-feature-settings:\"tnum\";font-feature-settings:\"tnum\"}.bb-tag:not(:last-child){margin-right:8px}"]
                    }] }
        ];
        BbTag.propDecorators = {
            onClose: [{ type: core.Output }]
        };
        return BbTag;
    }());
    if (false) {
        /** @type {?} */
        BbTag.prototype.onClose;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DECLARATIONS_EXPORTS = [
        // Directives.
        BbTemplate,
        BbInput,
        BbSelect,
        BbFocus,
        BbFocusTrap,
        BbAutosize,
        BbPrefix,
        BbSuffix,
        // Components.
        BbButton,
        BbAnchor,
        BbSpinner,
        BbIcon,
        BbFormControl,
        BbFormGroup,
        BbCheckbox,
        BbImagePicker,
        BbDropdown,
        BbDropdownItem,
        BbTag,
    ];
    var ElementsModule = /** @class */ (function () {
        function ElementsModule() {
        }
        /**
         * @return {?}
         */
        ElementsModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: ElementsModule,
                providers: [
                    { provide: ELEMENTS_ERRORS, useFactory: getErrors, multi: true },
                    ELEMENTS_MATERIAL_ICON
                ]
            };
        };
        ElementsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, localize.LocalizeModule],
                        declarations: __spread(DECLARATIONS_EXPORTS),
                        exports: __spread(DECLARATIONS_EXPORTS)
                    },] }
        ];
        return ElementsModule;
    }());
    var ɵ0 = { namespace: 'material', className: 'material-icons', type: 'font' };
    /** @type {?} */
    var ELEMENTS_MATERIAL_ICON = {
        provide: ELEMENTS_ICONS,
        useValue: ɵ0,
        multi: true
    };
    /**
     * @return {?}
     */
    function getErrors() {
        /** @type {?} */
        var data = {
            required: (/**
             * @return {?}
             */
            function () { return 'form-control-errors.required'; }),
            pattern: (/**
             * @return {?}
             */
            function () { return 'form-control-errors.pattern'; }),
            email: (/**
             * @return {?}
             */
            function () { return 'form-control-errors.email'; }),
            fullNumber: (/**
             * @return {?}
             */
            function () { return 'form-control-errors.fullNumber'; }),
            min: (/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var min = _a.min;
                return ({ token: 'form-control-errors.min', data: { min: min } });
            }),
            max: (/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var max = _a.max;
                return ({ token: 'form-control-errors.max', data: { max: max } });
            }),
            minlength: (/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var requiredLength = _a.requiredLength, actualLength = _a.actualLength;
                return ({
                    token: 'form-control-errors.minlength',
                    data: { requiredLength: requiredLength, actualLength: actualLength }
                });
            }),
            maxlength: (/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var requiredLength = _a.requiredLength, actualLength = _a.actualLength;
                return ({
                    token: 'form-control-errors.maxlength',
                    data: { requiredLength: requiredLength, actualLength: actualLength }
                });
            })
        };
        return data;
    }

    exports.BbAnchor = BbAnchor;
    exports.BbAutosize = BbAutosize;
    exports.BbButton = BbButton;
    exports.BbCheckbox = BbCheckbox;
    exports.BbFocus = BbFocus;
    exports.BbFocusTrap = BbFocusTrap;
    exports.BbFormControl = BbFormControl;
    exports.BbFormGroup = BbFormGroup;
    exports.BbIcon = BbIcon;
    exports.BbInput = BbInput;
    exports.BbPrefix = BbPrefix;
    exports.BbSelect = BbSelect;
    exports.BbSpinner = BbSpinner;
    exports.BbSuffix = BbSuffix;
    exports.BbTag = BbTag;
    exports.BbTemplate = BbTemplate;
    exports.ELEMENTS_MATERIAL_ICON = ELEMENTS_MATERIAL_ICON;
    exports.ElementsModule = ElementsModule;
    exports.getErrors = getErrors;
    exports.ɵa = ELEMENTS_ICONS;
    exports.ɵb = ELEMENTS_ERRORS;
    exports.ɵe = BbImagePicker;
    exports.ɵf = BbDropdown;
    exports.ɵg = BbDropdownItem;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=bravobit-bb-foundation-elements.umd.js.map
