import { ElementRef, OnDestroy, OnInit } from '@angular/core';
import { BbFormControl } from '../form-control/form-control.component';
import { FormGroupDirective, NgControl } from '@angular/forms';
export declare class BbSelect implements OnInit, OnDestroy {
    protected _elementRef: ElementRef;
    protected _ngControl: NgControl;
    protected _formControl: BbFormControl;
    protected _form: FormGroupDirective;
    protected hasArrow: boolean;
    private _subscription;
    constructor(_elementRef: ElementRef, _ngControl: NgControl, _formControl: BbFormControl, _form: FormGroupDirective);
    ngOnInit(): void;
    ngOnDestroy(): void;
    focus(): any;
    setFocus(hasFocus: boolean): void;
    readonly id: string;
    disabled: boolean;
    private _disabled;
    required: boolean;
    private _required;
    private readonly formSubmit;
    private readonly statusChanges;
    private readonly onFormReset;
}
export declare class BbInput extends BbSelect {
    protected _elementRef: ElementRef;
    protected _ngControl: NgControl;
    protected _formControl: BbFormControl;
    protected _form: FormGroupDirective;
    protected hasArrow: boolean;
    constructor(_elementRef: ElementRef, _ngControl: NgControl, _formControl: BbFormControl, _form: FormGroupDirective);
    readonly: boolean;
    private _readonly;
}
