import { Platform } from './platform.service';
export declare class ImageConverter {
    private _platform;
    private readonly _types;
    constructor(_platform: Platform);
    toDataUri(contents: string | File | HTMLImageElement, options?: {
        width: number;
        height: number;
    } | null): Promise<string>;
    private getImage;
    private fileToImage;
    private stringToImage;
    private calculateOffsetAndDimensions;
}
